/**
 * The scripting to make the Lithub MediaElement.js player and widget function.
 * Version: 1.0
 */
jQuery(document).ready(function($){
	mejs.MediaFeatures.isChromium = false;
	$.ajaxSetup({ 
		cache: false
	});
	
	var containers = $(".lithub-radio-container");
	for (var i = 0; i < containers.length; i++) {
		var container = containers[i];
		var key = $(container).data('podcast');
		//console.log("Found key: " + key);
		
		if (key == 'latest') key = '';
		fetchPodcast(container, key, false);
	}
	
	function fetchPodcast(container, key, autoplay) {
		$.ajax({
			type: 'GET',
			url: ajaxurl,
			data: {
				action: 'lh_podcast_latest_ep',
				key: key
			},
			success: function(response) {
				var json = JSON.parse(response);
				//console.log(json);
				$('.stream-name', container).html(json.show_name);
				$(container).css('display', 'block');
				var isNew = false;
				
				if ($('audio', container).length == 0) {
					$('.player-container', container).append('<audio src="' + json.downloadUrl + '" width="400px" preload="none" type="audio/mp3" style="width: 400px;"/>')
					
					$('audio', container).mediaelementplayer({
						features: ['playpause','progress','duration'],
						audioWidth: 600
					});
					isNew = true;
				}
				var showName = json.show_name + "-" + json.uid;
				
				var playerId = $('.mejs-container', container).attr('id');
				var player = mejs.players[playerId];
				if (player) {
					player.$media.bind('playing', function(e) {
						reportUse('playing', showName);
					});
					player.$media.bind('pause', function(e) {
						reportUse('pause', showName);
					});
					player.$media.bind('ended', function(e) {
						reportUse('ended', showName);
					});
					if (!isNew) {
						player.setSrc(json.downloadUrl);
					}
					
					if (autoplay) {
						player.play();
					}
				}
			}
		});
	}
	
	function reportUse(e, showName) {
		var eventName = "";
		if (e == 'playing') {
			eventName = 'Playing';
		} else if (e == 'pause') {
			eventName = 'Paused';
		} else if (e == 'ended') {
			eventName = 'Completed';
		}
		//console.log("Logging event: " + eventName + ", showName: " + showName);
		if (ga) {
			ga('send', {
			  hitType: 'event',
			  eventCategory: 'Podcasts',
			  eventAction: eventName,
			  eventLabel: showName
			});
		}
	}
	
	$('.lithub-radio-container .station-button').click(function(){
		var button = $(this);
		var container = button.parentsUntil(".lithub-radio-container").parent().get(0);
		
		var playerId = $('.mejs-container', container).attr('id');
		var player = mejs.players[playerId];
		if (player) {
			player.pause();
		}
		
		var key = button.data("key");
		if (ga) {
			ga('send', {
			  hitType: 'event',
			  eventCategory: 'Podcasts',
			  eventAction: 'StationSelect',
			  eventLabel: key
			});
		}
		
		fetchPodcast(container, key, true);
	})
	
	$('.lithub-radio-container .stations-slider .stations-arrow').click(function() {
		//console.log("Should be animating...");
		//$('.lithub-radio-container .stations-slider .stations-scroll').animate({
		$('.lithub-radio-container .stations-slider').animate({
			'scrollLeft': "+=70"
		}, {
			duration: 300,
			easing: 'easeInOutBounce',
			done: function() {
				//console.log("Done animating");
			}
		});
	})
});
